function SetupModelInformation()
{
  ParsePageQuery();
  window.cellml = GetCellMLModel().QueryInterface(Components.interfaces.mozICellMLLocal);
  document.getElementById("modelname").value += " " + window.cellml.title;
  
}

function CloseModelTab()
{
  CloseCellMLModel();
}

function SelectLocalSave(returnto)
{
  var strb = document.getElementById("mozcellml-string-bundle");
  try
  {
    const nsIFilePicker = Components.interfaces.nsIFilePicker;
    var fp = Components.classes["@mozilla.org/filepicker;1"]
                       .createInstance(nsIFilePicker);
    fp.init(window, strb.getString("chooseSaveFilename"),
            nsIFilePicker.modeSave);
    fp.appendFilter(strb.getString("allCellML"), "*.cml; *.xml");
    fp.appendFilter("CML", "*.cml");
    fp.appendFilter("XML", "*.xml");
    fp.appendFilter(strb.getString("allFiles"), "*");
    if (fp.show() == nsIFilePicker.returnCancel)
      return;
    returnto.value = fp.file.path;
  }
  catch (ex)
  {
  }
}

function UserRequestSave(saveto, model)
{
  var strb = document.getElementById("mozcellml-string-bundle");
  var file = Components.classes["@mozilla.org/file/local;1"]
                    .createInstance(Components.interfaces.nsILocalFile);
  try
  {
    file.initWithPath(saveto);
  }
  catch (e)
  {
    var statusBar = GetStatusBar();
    statusBar.label = strb.getString("cantSaveToPath");
    return;
  }
  var stream = Components.classes["@mozilla.org/network/file-output-stream;1"]
                    .createInstance(Components.interfaces.nsIFileOutputStream);
  var serializer = Components.classes["@mozilla.org/xmlextras/xmlserializer;1"]
                    .createInstance(Components.interfaces.nsIDOMSerializer);
  stream.init(
              file,
              /* PR_WRONLY | PR_CREATE_FILE | PR_TRUNCATE */
              42,
              /*0644*/420,
              0
             );
  var savedom = window.cellml.DOM;
  serializer.serializeToStream(savedom, stream, "UTF8");
}
