function HideAllIFrames(e)
{
  var ifrs = e.getElementsByTagName("iframe");
  var i;
  for (i = 0; i < ifrs.length; i++)
  {
    var ifr = ifrs.item(i);
    ifr.oldvisibility = ifr.style.visibility;
    ifr.style.display = "none";
  }
}

function RestoreAllIFrames(e)
{
  var ifrs = e.getElementsByTagName("iframe");
  var i;
  for (i = 0; i < ifrs.length; i++)
  {
    var ifr = ifrs.item(i);
    ifr.style.display = ifr.oldvisibility;
  }
}

function VWindow(w, title)
{
  this.minWidth = 550;
  this.minHeight = 250;
  this.win = w;
  this.doc = w.document;
  this.body = this.doc.documentElement.getElementsByTagName("div").item(0);

  this.node = this.body.getElementsByTagName("div").item(0).cloneNode(true);
  this.node.setAttribute("id", "just-added-id");
  this.body.appendChild(this.node);
  this.node = this.doc.getElementById("just-added-id");
  this.node.removeAttribute("id");

  var csstxt = this.doc.defaultView.getComputedStyle(this.node, "").cssText;
  this.node.setAttribute("style", csstxt);
  this.style = this.node.style;
  this.style.display = "inline";
  this.menubar = this.node.getElementsByTagName("div").item(0);
  this.title = this.menubar
                   .getElementsByTagName("div").item(0);
  this.mmicon = this.menubar
                    .getElementsByTagName("img").item(2);
  this.contentArea = this.node.getElementsByTagName("div").item(2)
  this.left = 100;
  this.right = 100;
  this.top = 30;
  this.bottom = 30;
  if (w.windowCounter == null)
    w.windowCounter = 1;
  this.zIndex = w.windowCounter;
  w.windowCounter++;

  if (w.windowId == null)
    w.windowId = 1;
  this.windowId = w.windowId;
  w.windowId++;
  if (w.windows == null)
    w.windows = [];

  w.windows[this.windowId] = this;
  this.style.zIndex = this.zIndex;

  this.menuitem = document.createElementNS
           (
            "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul",
            "menuitem"
           );
  this.menuitem.vwindow = this;
  this.setTitle(title);
  this.node.vwindow = this;
  this.maximised = false;
  this.menuitem.setAttribute("onclick", "focusclick(event, this);");

  this.win.menu.appendChild(this.menuitem);

  return this;
}

VWindow.prototype =
{
  setTitle: function(x)
  {
    var txt = this.title.childNodes.item(0);
    this.menuitem.setAttribute("label", x);
    txt.nodeValue = x;
  },

  focusClick: function()
  {
    if (this.win.focuswindow == this)
      return;
    if (this.win.focuswindow != null)
      this.win.focuswindow.lostFocus();
    var lf = this.win.focuswindow;
    this.win.focuswindow = this;
    this.gotFocus(lf);
  },

  startResize: function(e, dir)
  {
    if (this.maximised && dir == 6)
      return;
    this.win.resizingWindow = this;
    var trl = new TerminateResizeListener(this);
    var rml = new ResizeMoveListener(this);
    trl.rml = rml;
    HideAllIFrames(this.body);
    this.body.addEventListener("mousemove", rml, true);
    this.body.addEventListener("mouseout", rml, true);
    this.body.addEventListener("mouseup", trl, true);
    this.resizeDirection = dir;
    this.startX = e.clientX - this.left;
    this.startY = e.clientY - this.top;
    this.setMaxIcon("icon-maxwindow");
    this.maximised = false;
    this.trl = trl;
  },

  resizeEvent: function(event)
  {
    var x = event.clientX;
    var y = event.clientY;

    if (x == 0 || y == 0 || x >= (this.win.innerWidth-1) || y >= (this.win.innerHeight-1))
      this.trl.handleEvent(null);

    if (this.resizeDirection == 1) // Left
    {
      if (this.win.innerWidth - this.right - x < this.minWidth)
      {
        x = this.win.innerWidth - this.right - this.minWidth;
        if (x < 0)
          return;
      }
      this.left = x;
      if (this.left <= 10)
        this.left = 0;
      this.style.left = this.left + "px";
    }
    else if (this.resizeDirection == 2) // Right
    {
      if (x - this.left < this.minWidth)
      {
        x = parseInt(this.minWidth) + parseInt(this.left);
      }
      this.right = (this.win.innerWidth - x);
      if (this.right <= 10)
        this.right = 0;
      this.style.right = this.right + "px";
    }
    else if (this.resizeDirection == 3) // Bottom
    {
      if (y - this.top < this.minHeight)
        y = parseInt(this.minHeight) + parseInt(this.top);
      this.bottom = (this.win.innerHeight - y);
      if (this.bottom <= 10)
        this.bottom = 0;
      this.style.bottom = this.bottom + "px";
    }
    else if (this.resizeDirection == 4) // South east...
    {
      if (y - this.top < this.minHeight)
        y = parseInt(this.minHeight) + parseInt(this.top);
      if (x - this.left < this.minWidth)
      {
        x = parseInt(this.minWidth) + parseInt(this.left);
      }

      this.right = (this.win.innerWidth - x);
      if (this.right <= 10)
        this.right = 0;

      this.style.right = this.right + "px";

      this.bottom = (this.win.innerHeight - y);
      if (this.bottom <= 10)
        this.bottom = 0;

      this.style.bottom = this.bottom + "px";
    }
    else if (this.resizeDirection == 5) // South west...
    {
      if (y - this.top < this.minHeight)
        y = parseInt(this.minHeight) + parseInt(this.top);
      if (this.win.innerWidth - this.right - x < this.minWidth)
      {
        x = this.win.innerWidth - this.right - this.minWidth;
        if (x < 0)
          return;
      }

      this.left = x;
      if (this.left <= 10)
        this.left = 0;
      this.style.left = this.left + "px";

      this.bottom = (this.win.innerHeight - y);
      if (this.bottom <= 10)
        this.bottom = 0;
      this.style.bottom = this.bottom + "px";
    }
    else if (this.resizeDirection == 7) // Top...
    {
      if (this.win.innerHeight - this.bottom - y < this.minHeight)
      {
        y = this.win.innerHeight - this.bottom - this.minHeight;
        if (y < 0)
          return;
      }
      this.top = y;
      if (this.top <= 10)
        this.top = 0;
      this.style.top = this.top + "px";
    }
    else if (this.resizeDirection == 8) // North east...
    {
      if (this.win.innerHeight - this.bottom - y < this.minHeight)
      {
        y = this.win.innerHeight - this.bottom - this.minHeight;
        if (y < 0)
          return;
      }
      if (x - this.left < this.minWidth)
      {
        x = parseInt(this.minWidth) + parseInt(this.left);
      }

      this.top = y;
      if (this.top <= 10)
        this.top = 0;
      this.style.top = this.top + "px";

      this.right = (this.win.innerWidth - x);
      if (this.right <= 10)
        this.right = 0;
      this.style.right = this.right + "px";
    }
    else if (this.resizeDirection == 9) // North west...
    {
      if (this.win.innerHeight - this.bottom - y < this.minHeight)
      {
        y = this.win.innerHeight - this.bottom - this.minHeight;
        if (y < 0)
          return;
      }
      if (this.win.innerWidth - this.right - x < this.minWidth)
      {
        x = this.win.innerWidth - this.right - this.minWidth;
        if (x < 0)
          return;
      }

      this.top = y;
      if (this.top <= 10)
        this.top = 0;
      this.style.top = this.top + "px";

      this.left = x;
      if (this.left <= 10)
        this.left = 0;
      this.style.left = this.left + "px";
    }
    else if (this.resizeDirection == 6) // Move
    {
      var width = (this.win.innerWidth - this.right) - this.left;
      var height = (this.win.innerHeight - this.bottom) - this.top;
      var ot = this.top, ol = this.left, o_r = this.right, ob = this.bottom;
      if ((this.win.innerWidth - ((x - this.startX) + width)) <= 10)
      {
        // Interpret as a request to dock on the right edge of the region...
        x = this.win.innerWidth + this.startX - width;
      }
      else if (x - this.startX <= 10)
      {
        // Interpret as a request to dock on the left edge of the region...
        x = this.startX;
      }
      if ((this.win.innerHeight - ((y - this.startY) + height)) <= 10)
      {
        // Interpret as a request to dock on the bottom edge of the region...
        y = this.win.innerHeight + this.startY - height;
      }
      else if (y - this.startY <= 10)
      {
        // Interpret as a request to dock on the top edge of the region...
        y = this.startY;
      }

      this.top = y - this.startY;
      this.style.top = this.top + "px";
      this.left = x - this.startX;
      this.style.left = this.left + "px";
      this.right = this.win.innerWidth - (this.left + width);
      this.bottom = this.win.innerHeight - (this.top + height);
      this.style.right = this.right + "px";
      this.style.bottom = this.bottom + "px";
    }
  },

  setPosition: function(l, r, t, b)
  {
    this.left = l;
    this.right = r;
    this.top = t;
    this.bottom = b;
    this.style.top = this.top + "px";
    this.style.left = this.left + "px";
    this.style.right = this.right + "px";
    this.style.bottom = this.bottom + "px";
  },

  setSize: function(w, h)
  {
    this.right = this.win.innerWidth - this.left - w;
    if (this.right < 0)
      this.right = 0;
    this.bottom = this.win.innerHeight - this.top - h;
    if (this.bottom < 0)
      this.bottom = 0;
    this.style.right = this.right + "px";
    this.style.bottom = this.bottom + "px";
  },

  onRequestClose: function()
  {
    this.performClose();
  },

  performClose: function()
  {
    this.body.removeChild(this.node);
    this.win.menu.removeChild(this.menuitem);
    delete this.win.windows[this.windowId];
  },

  onRequestMaxMin: function()
  {
    if (this.maximised)
      this.restoreSize();
    else
      this.maximise();
  },

  maximise: function()
  {
    this.restoreTop = this.top;
    this.restoreLeft = this.left;
    this.restoreRight = this.right;
    this.restoreBottom = this.bottom;
    this.top = 0;
    this.left = 0;
    this.right = 0;
    this.bottom = 0;
    this.style.top = this.top + "px";
    this.style.left = this.left + "px";
    this.style.right = this.right + "px";
    this.style.bottom = this.bottom + "px";
    this.maximised = true;
    this.setMaxIcon("icon-restorewindow");
  },

  restoreSize: function()
  {
    this.top = this.restoreTop;
    this.left = this.restoreLeft;
    this.right = this.restoreRight;
    this.bottom = this.restoreBottom;
    this.style.top = this.top + "px";
    this.style.left = this.left + "px";
    this.style.right = this.right + "px";
    this.style.bottom = this.bottom + "px";
    this.maximised = false;
    this.setMaxIcon("icon-maxwindow");
  },

  setMaxIcon: function(x)
  {
    this.mmicon.setAttribute("src", "chrome://mozcellml/skin/images/" + x + ".gif");
  },

  lostFocus: function()
  {
    this.menubar.setAttribute("focus", "false");
  },

  gotFocus: function(old)
  {
    this.menuitem.setAttribute("checked", "true");
    if (old != null)
      old.menuitem.setAttribute("checked", "false");
    this.menubar.setAttribute("focus", "true");
    this.zIndex = this.win.windowCounter;
    this.win.windowCounter++;
    this.style.zIndex = this.zIndex;
  },

  loadScript: function(filename)
  {
    var sel = this.doc.createElementNS("http://www.w3.org/1999/xhtml", "script");
    sel.setAttribute("type", "text/javascript");
    sel.setAttribute("src", "chrome://mozcellml/content/" + filename);
    this.doc.documentElement.insertBefore(sel, this.doc.documentElement.childNodes.item(0));
    if (this.load_scripts == null)
      this.load_scripts = [];
    this.load_scripts.push(filename);
  },

  loadContent: function(doc, name)
  {
    var node = doc.getElementById(name);
    this.repoDocument = doc;
    this.loadedContent = this.doc.importNode(node, true);
    this.contentArea.appendChild(this.loadedContent);
    if (this.load_content == null)
      this.load_content = [];
    this.load_content.push(name);
  },

  setOverride: function(overrides, name)
  {
    var f = overrides[name];
    this.override = name;
    f(this);
  },

  saveState: function(doc, node)
  {
    if (this.win.focuswindow == this)
      node.setAttribute("focused", "true");
    node.setAttribute("zIndex", this.zIndex);
    node.setAttribute("top", this.top);
    node.setAttribute("bottom", this.bottom);
    node.setAttribute("left", this.left);
    node.setAttribute("right", this.right);
    if (this.override != null)
      node.setAttribute("override", this.override);
    var titleNode = doc.createElement("title");
    titleNode.appendChild(doc.createTextNode(this.title.childNodes.item(0).nodeValue));
    node.appendChild(titleNode);
    var i;
    if (this.load_scripts != null)
    {
      for (i = 0; i < this.load_scripts.length; i++)
      {
        var lsn = doc.createElement("script");
        lsn.setAttribute("href", this.load_scripts[i]);
        node.appendChild(lsn);
      }
    }
    if (this.load_content != null)
    {
      for (i = 0; i < this.load_content.length; i++)
      {
        var lsn = doc.createElement("loadcontent");
        lsn.setAttribute("source", this.load_content[i]);
        node.appendChild(lsn);
      }
    }
    if (this.saveContent != null)
    {
      var cn = doc.createElement("content");
      this.saveContent(cn);
      node.appendChild(cn);
    }
  },

  restoreState: function(overrides, parentdoc, node)
  {
    this.zIndex = node.getAttribute("zIndex");
    this.top = node.getAttribute("top");
    this.bottom = node.getAttribute("bottom");
    this.left = node.getAttribute("left");
    this.right = node.getAttribute("right");
    this.override = node.getAttribute("override");
    if (this.override != null)
    {
      var f = overrides[this.override];
      f(this);
    }

    this.style.left = this.left + "px";
    this.style.right = this.right + "px";
    this.style.top = this.top + "px";
    this.style.bottom = this.bottom + "px";

    this.style.zIndex = this.zIndex;

    var t = node.getElementsByTagName("title").item(0);
    this.setTitle(t.childNodes.item(0).nodeValue);

    var loadel = node.getElementsByTagName("script");
    var i;
    for (i = 0; i < loadel.length; i++)
    {
      var hr = loadel.item(i).getAttribute("href");
      /* We need to put hr through some security checks, otherwise we have just
       * made workspaces, which we encourage people to swap, into a
       * virus vector. Restricting them to [a-z|A-Z|\_|\-]\.js seems
       * to make sense.
       */
      if (hr.match("^[A-Z|a-z|\\_|\\-]+\.js$") == null)
      {
        alert("Script not allowed due to security policy.");
        continue;
      }
      this.loadScript(hr);
    }
    var loadel = node.getElementsByTagName("loadcontent");
    var i;
    for (i = 0; i < loadel.length; i++)
      this.loadContent(parentdoc, loadel.item(i).getAttribute("source"));
    if (this.setupForContent != null)
      this.setupForContent(this.loadedContent);
    if (this.restoreContent != null)
    {
      var contentel = node.getElementsByTagName("content");
      if (contentel.length > 0)
        this.restoreContent(contentel.item(0));
    }
  }
}

function resizeleft(e, x)
{
  window.menu.style.display = "none";
  x.parentNode.vwindow.startResize(e, 1);
}

function resizeright(e, x)
{
  window.menu.style.display = "none";
  x.parentNode.vwindow.startResize(e, 2);
}

function resizebottom(e, x)
{
  window.menu.style.display = "none";
  x.parentNode.vwindow.startResize(e, 3);
}

function resizese(e, x)
{
  window.menu.style.display = "none";
  x.parentNode.vwindow.startResize(e, 4);
}

function resizesw(e, x)
{
  window.menu.style.display = "none";
  x.parentNode.vwindow.startResize(e, 5);
}

function grabmenu(e, x)
{
  window.menu.style.display = "none";
  if (e.button == 0)
    x.parentNode.vwindow.startResize(e, 6);
}

function focusclick(e, x)
{
  x.vwindow.win.menu.style.display = "none";
  x.vwindow.focusClick();
}

function resizetop(e, x)
{
  window.menu.style.display = "none";
  x.parentNode.vwindow.startResize(e, 7);
}

function resizene(e, x)
{
  window.menu.style.display = "none";
  x.parentNode.vwindow.startResize(e, 8);
}

function resizenw(e, x)
{
  window.menu.style.display = "none";
  x.parentNode.vwindow.startResize(e, 9);
}

function TrackMouseMovements(e)
{
  if (window.resizingWindow != null)
    window.resizingWindow.resizeEvent(e);
}

function TerminateResizeListener(w)
{
  this.resizingWindow = w;
  return this;
}

TerminateResizeListener.prototype = 
{
  QueryInterface: function(iid)
  {
    if (iid.equals(Components.interfaces.nsISupports) ||
        iid.equals(Components.interfaces.nsIDOMEventListener))
      return this;
    throw Components.results.NS_ERROR_NO_INTERFACE;
  },

  handleEvent: function(e)
  {
    var rw = this.resizingWindow;
    if (rw == null)
      return;
    this.resizingWindow = null;
    var t = this;
    rw.body.removeEventListener("mouseup", this, true);
    rw.body.removeEventListener("mouseout", t.rml, true);
    rw.body.removeEventListener("mousemove", t.rml, true);
    RestoreAllIFrames(rw.body);
  }
};

function ResizeMoveListener(w)
{
  this.resizingWindow = w;
  return this;
}

ResizeMoveListener.prototype = 
{
  QueryInterface: function(iid)
  {
    if (iid.equals(Components.interfaces.nsISupports) ||
        iid.equals(Components.interfaces.nsIDOMEventListener))
      return this;
    throw Components.results.NS_ERROR_NO_INTERFACE;
  },

  handleEvent: function(e)
  {
    if (this.resizingWindow != null)
    {
      this.resizingWindow.resizeEvent(e);
    }
  }
};

function TileWindowsVertically(w)
{
  // Find how much space is available...
  var avail = w.innerHeight;
  // Have to actually count them, as there can be gaps...
  var wid, wc=0;
  for (wid in w.windows)
    wc++;
  // If there aren't any windows, we are done...
  if (wc == 0)
    return;
  
  var perwin = avail / wc;

  var ctop = 0;
  for (wid in w.windows)
  {
    var cbottom = avail - (ctop + perwin);
    var vwin = w.windows[wid];
    vwin.top = ctop;
    vwin.bottom = cbottom;
    vwin.left = 0;
    vwin.right = 0;
    vwin.style.top = vwin.top + "px";
    vwin.style.bottom = vwin.bottom + "px";
    vwin.style.left = vwin.left + "px";
    vwin.style.right = vwin.right + "px";
    ctop = ctop + perwin;
  }
}

function TileWindowsHorizontally(w)
{
  // Find how much space is available...
  var avail = w.innerWidth;
  // Have to actually count them, as there can be gaps...
  var wid, wc=0;
  for (wid in w.windows)
    wc++;
  // If there aren't any windows, we are done...
  if (wc == 0)
    return;
  
  var perwin = avail / wc;

  var cleft = 0;
  for (wid in w.windows)
  {
    var cright = avail - (cleft + perwin);
    var vwin = w.windows[wid];
    vwin.left = cleft;
    vwin.right = cright;
    vwin.top = 0;
    vwin.bottom = 0;
    vwin.style.top = vwin.top + "px";
    vwin.style.bottom = vwin.bottom + "px";
    vwin.style.left = vwin.left + "px";
    vwin.style.right = vwin.right + "px";
    cleft = cleft + perwin;
  }
}

function CloseButtonClicked(e, cbc)
{
  window.menu.style.display = "none";
  e.stopPropagation();
  cbc.parentNode.parentNode.vwindow.onRequestClose();
}

function MaxMinButtonClicked(e, cbc)
{
  window.menu.style.display = "none";
  e.stopPropagation();
  cbc.parentNode.parentNode.vwindow.onRequestMaxMin();
}

function SetupMenu(b)
{
  var pm = document.createElementNS
           (
            "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul",
            "menupopup"
           );
  // pm.setAttribute("id", "select-window-mp");
  window.menu = pm;
  // pm = window.menu.cloneNode(true);
  pm.setAttribute("style", "display: none; position: absolute; left: 0px; top: 0px;");
  document.getElementsByTagName("div").item(0).appendChild(pm);
}

function createContextMenu(e, cbc)
{
  window.menu.style.left = e.clientX + "px";
  window.menu.style.top = e.clientY + "px";
  window.menu.style.display = "inline";
}
