#!/usr/bin/python
# Copyright (C) 2001,  Christof Meerwald <cmeerw@web.de>
# http://xpcom2corba.sunsite.dk/

# XPCOM-CORBA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 dated June, 1991.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.

import sys

import xpcom.components


CORBA_ORBPROXY_CONTRACTID = '@xpcom2corba.sunsite.dk/CORBA/ORBProxy;1'

orbproxy = xpcom.components.classes[CORBA_ORBPROXY_CONTRACTID].createInstance(xpcom.components.interfaces.CORBA_IORBProxy)

print 'trying to load CosNaming module'
if not orbproxy.load_module('CosNaming'):
    print 'failed...'

print 'trying to get NameService reference'
nctx = orbproxy.resolve_initial_references('NameService')
nctx.queryInterface(xpcom.components.interfaces.CosNaming_INamingContextExt)

while len(sys.argv) > 1:
    print 'trying to resolve command line argument'
    nctx = nctx.resolve_str(sys.argv[1])
    nctx.queryInterface(xpcom.components.interfaces.CosNaming_INamingContextExt)
    sys.argv = [sys.argv[0]] + sys.argv[2:]

print 'trying to list naming context'
bind_list, bind_iter = nctx.list(0)

cont = 1
while cont:
    cont, binding = bind_iter.next_one()
    if cont:
        if binding.binding_type:
            bind_type = '/'
        else:
            bind_type = ''

        for bind_comp in binding.getBinding_name():
            # hmm, why do we need this queryInterface herer?
            bind_comp.queryInterface(xpcom.components.interfaces.CosNaming_INameComponent)

            comp_id, comp_kind = (bind_comp.id, bind_comp.kind)
            if not comp_kind:
                print comp_id + bind_type
            else:
                print comp_id + '.' + comp_kind + bind_type

bind_iter.destroy()
