/*	-*- C++ -*-
 * Copyright (C) 2001,  Christof Meerwald <cmeerw@web.de>
 * http://xpcom2corba.sunsite.dk/
 */

/*
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License
 * at http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific language governing rights and
 * limitations under the License.
 *
 * The Original Code is the XPCOM-CORBA Bridge package.
 *
 * The Initial Developer of the Original Code is Christof Meerwald.
 * Portions created by Christof Meerwald are Copyright (C) 2001
 * Christof Meerwald.  All Rights Reserved.
 *
 * Contributor(s): Christof Meerwald <cmeerw@web.de> (original author)
 */
#ifndef HEADER__CORBA_LOCATOR__INCLUDED
#define HEADER__CORBA_LOCATOR__INCLUDED

#include "cstring_util.h"

#include <CORBA.h>
#include <prtypes.h>
#include "xpcom.hh"

#include <map>


class CORBA_Proxy_Object;


class CORBA_Proxy_Locator
  : public POA_PortableServer::ServantLocator
{
 public:
  CORBA_Proxy_Locator();

  ~CORBA_Proxy_Locator();


  virtual PortableServer::Servant preinvoke(const PortableServer::ObjectId &oid,
					    PortableServer::POA_ptr adapter,
                                            const char *operation,
                                            PortableServer::ServantLocator::Cookie &the_cookie);

  virtual void postinvoke(const PortableServer::ObjectId &oid,
                          PortableServer::POA_ptr adapter,
                          const char *operation,
                          PortableServer::ServantLocator::Cookie the_cookie,
                          PortableServer::Servant the_servant);


  const char *register_proxy(CORBA_Proxy_Object *proxy_obj);

  void unregister_proxy(const char *oid_str);


 private:
  typedef std::map<const char *, CORBA_Proxy_Object *, cstring_Less> Oid_Map;

  Oid_Map oids_;

  PRInt32 oid_counter_;
};

#endif
